/*
 * glFeedback, an OpenGL Feedback processing Library
 * Copyright (C) 2003 Francesco Bradascio
 *
 * E-mail: fbradasc@katamail.com
 * URL: http://digilander.libero.it/fbradasc/GL_FEEDBACK.html
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * This work is mostly based on the GL2PS Library which is:
 *
 * Copyright (C) 1999-2003 Christophe Geuzaine
 * E-mail: geuz@geuz.org
 * URL: http://www.geuz.org/gl2ps/
 *
 * GL2PS Contributor(s):
 *   Michael Sweet <mike@easysw.com>
 *   Marc Ume <marc.ume@digitalgraphics.be>
 *   Jean-Francois Remacle <remacle@scorec.rpi.edu>
 *   Bart Kaptein <B.L.Kaptein@lumc.nl>
 *   Quy Nguyen-Dai<quy@vnilux.com>
 *   Sam Buss <sbuss@ucsd.edu>
 *   Shane Hill <Shane.Hill@dsto.defence.gov.au>
 *   Romain Boman <r_boman@yahoo.fr>
 *   Rouben Rostamian <rostamian@umbc.edu>
 *   Diego Santa Cruz <Diego.SantaCruz@epfl.ch>
 *   Shahzad Muzaffar <Shahzad.Muzaffar@cern.ch>
 *   Lassi Tuura <lassi.tuura@cern.ch>
 *   Guy Barrand <barrand@lal.in2p3.fr>
 */

#ifndef __GLFBspTree_H
#define __GLFBspTree_H

#include <GLF/glFeedback.h>
#include <GLF/GLFxyz.h>
#include <GLF/GLFPrimitive.h>
#include <GLF/GLFPrimitives.h>

class GLF_API GLFBspTree
{
public:

    GLFBspTree    *front;
    GLFBspTree    *back;
    GLFPrimitives  primitives;
    GLFPrimitives *storage;
    GLFplane       plane;

    GLFBspTree (
        GLint maxBestRoot,
        GLFPrimitives& primitives,
        GLFPrimitives* storage
    );
    ~GLFBspTree();
    void traverse (
        const GLFxyz &eye,
        GLfloat epsilon,
        GLboolean (*compare)(GLfloat f1, GLfloat f2),
        void (*action)(GLFPrimitive& prim, void *data),
        void *data
    );
#if 0
    void addBoundaryInList(GLFPrimitive& prim);
    void buildPolygonBoundary(void);
#endif
};

#endif // __GLFBspTree_H
